Foxit PDF SDK

Public Member Functions | Public Attributes | Static Public Attributes | List of all members
FSDK.Renderer Class Reference

## Public Member Functions
| ClearClips ()
| Clear the clipping rectangle set by function FSDK.Renderer.SetClipRect. More...
| constructor (bitmap, is_rgb_order)
| Constructor, with bitmap. More...
| EnableForPrint (is_render_for_print)
| Set the flag to decide whether to do rendering in print mode. More...
| IsEmpty ()
| RenderAnnot (annot, matrix)
| Render a specified annotation. More...
| RenderFormControls (page, matrix)
| Render form controls. More...
| RenderGraphicsObject (graphics_object, page, matrix)
| Render a graphics object. More...
| SetClearType (is_clear_type)
| Set the flag to decide whether to use ClearType-like anti-aliasing to render text objects. More...
| SetClipPathFill (clip_path, matrix, fill_mode)
| Set clipping path using filled region. More...
| SetClipPathStroke (clip_path, matrix, graph_state)
| Set clipping path using stroked region. More...
| SetClipRect (clip_rect)
| Set the clipping rectangle which will be used in subsequent rendering progress. More...
| SetColorMode (color_mode)
| Set color mode. More...
| SetForceDownSample (is_to_force_down_sample)
| Set the flag to decide whether to use down-sampling for image stretching. More...
| SetForceHalftone (is_to_force_halftone)
| Set the flag to decide whether to use halftone for image stretching. More...
| SetForegroundColor (foreground_color)
| Set foreground color for text, path or both when color mode is FSDK.Renderer.e_ColorModeForeground. More...
| SetForegroundColorMode (foreground_color_mode)
| Set rendering foreground color mode when color mode is FSDK.Renderer.e_ColorModeForeground. More...
| SetJPEGDownSample (is_jepg_down_sample)
| Set the flag to decide whether to use down-sampling for jpeg image. More...
| SetJPXDownSample (is_jpx_down_sample)
| Set the flag to decide whether to use down-sampling for jpx image. More...
| SetLayerContext (layer_context)
| Set layer context to render context handle. More...
| SetMappingModeColors (background_color, foreground_color)
| Set background color and foreground color when color mode is FSDK.Renderer.e_ColorModeMappingGray or FSDK.Renderer.e_ColorModeMapping. More...
| SetOverprint (is_to_enable_overprint)
| Set the flag to decide whether to enable overprint. More...
| SetPrintTextAsGraphic (is_to_print_text_graphic)
| Set the flag to decide whether to print text as path or bitmap. More...
| SetPrintTextAsImage (is_to_print_text_image)
| Set the flag to decide whether to print text as image. More...
| SetRenderAnnotAppearanceType (ap_type)
| Set the annotation's appearance type for rendering. More...
| SetRenderAnnotsForThumbnail (is_render_annots_for_thumbnail)
| Set rendering flag to decide whether to render annotations in thumbnail mode or not. More...
| SetRenderContentFlags (render_content_flags)
| Set rendering flag to decide what content will be rendered. More...
| SetRenderEnhanceThinLines (is_render_enhance_thin_lines)
| Set the flag to decide whether to enhance thin lines. More...
| SetRenderFormField (is_render_formfield)
| Set the flag to decide whether to render form fields (except signature fields). More...
| SetRenderImageAntiAliasing (is_render_image_antialiasing)
| Set the flag to decide whether to draw image anti-aliasing. More...
| SetRenderLayer (is_render_one_layer)
| Set the flag to decide whether to render one layer or all available layers. More...
| SetRenderPathAntiAliasing (is_render_path_antialiasing)
| Set the flag to decide whether to draw path anti-aliasing. More...
| SetRenderPathFullCovered (is_render_path_full_covered)
| A special flag that can be applied to fill mode. More...
| SetRenderPathThinLine (is_render_path_thin_line)
| Set the flag to decide whether to draw path as thin line. More...
| SetRenderSignature (is_render_signature)
| Set the flag to decide whether to render signatures or not. More...
| SetRenderSignatureState (is_render_signature_state)
| Set the flag to decide whether to draw the signature state on the signature. More...
| SetRenderTextAntiAliasing (is_render_text_antialiasing)
| Set the flag to decide whether to draw text anti-aliasing. More...
| SetScreenDPIScale (scale)
| Set the screen DPI scaling factor for rendering. More...
| StartQuickRender (page, matrix, pause)
| Start to quickly render a PDF page, mainly for thumbnail purpose. More...
| StartRender (page, matrix, pause)
| Start to render a PDF page. More...
| StartRenderBitmap (bitmap, matrix, clip_rect, interpolation, alpha, pause)
| Start to render a bitmap. More...
| StartRenderBitmap (bitmap, matrix, clip_rect, interpolation, pause)
| Start to render a bitmap. More...
| StartRenderReflowPage (reflow_page, matrix, pause)
| Start to render a reflow page. More...
| StartRenderXFAPage (xfa_page_view, matrix, is_highlight, pause)
| Start to render an XFA page. More...

## Public Attributes
| e_RenderAnnot
| If set, annotations will be rendered.
| e_RenderExceptHighLight
| If set, all annotations expect highlight will be rendered.
| e_RenderHighLight
| If set, only highlight annotations will be rendered.
| e_RenderPage
| Enumeration for rendering content flags. More...
| e_RenderScreen
| If set, only screen annotations will be rendered.

## Static Public Attributes
static | e_ColorModeMapping
| Map a color value to the color range defined by a background color and a foreground color.
static | e_ColorModeMappingGray
| Map gray/white/black color value to background/foreground; for other colors, no change.
static | e_ColorModeNormal
| Enumeration for rendering color mode. More...

## Detailed Description

PDF renderer is a graphics engine and is used to render page to a bitmap or a platform device context. This class can be constructed with a bitmap, or a device object. It offers functions to set rendering options/flags, and do rendering. In this class, there are several ways to do rendering:

- To render page and annotations, first use function FSDK.Renderer.SetRenderContentFlags to decide whether to render page and annotation both or not, and then use functions FSDK.Renderer.StartRender to do the rendering. Function FSDK.Renderer.StartQuickRender can also be used to render page but only for thumbnail purpose.
- To render a single annotation, use function FSDK.Renderer.RenderAnnot.
- To render a bitmap, use function FSDK.Renderer.StartRenderBitmap.
- To render a reflow page, use function FSDK.Renderer.StartRenderReflowPage.

Widget annotation is always associated with form field and form control in Foxit PDF SDK. For how to render widget annotations, here is a recommended flow:

- After loading a PDF page, first render the page and all annotations in this page (including widget annotations).
- Then, if user uses FSDK.Filler object to fill the form, user should use function FSDK.Filler.Render to render the focused form control instead of using function FSDK.Renderer.RenderAnnot.

See also
  FSDK.Filler

## Member Function Documentation

## ◆ ClearClips()

FSDK.Renderer.ClearClips | ( |  | ) |

Clear the clipping rectangle set by function FSDK.Renderer.SetClipRect.

Returns
  None.

## ◆ constructor()

FSDK.Renderer.constructor | ( | bitmap | ,
|  | is_rgb_order |
| ) |  |

Constructor, with bitmap.

The input bitmap is treated as an independent device and all the content rendered by the renderer would appear in the bitmap.

Parameters

  [in] | bitmap | A bitmap used for rendering. User should ensure the bitmap to keep valid until the end of life cycle of current renderer object. The format of bitmap should not be FSDK.Bitmap.e_DIB1bpp.
  [in] | is_rgb_order | true means Foxit PDF SDK needs to use RGB byte-order (Red is in the lowest order) when rendering. false means Foxit PDF SDK needs to use BGR byte-order (Blue is in the lowest order) when rendering.

## ◆ EnableForPrint()

FSDK.Renderer.EnableForPrint | ( | is_render_for_print |  | ) |

Set the flag to decide whether to do rendering in print mode.

Please ensure this rendering flag is set as expected when current renderer is to used for printing. For rendering annotations, if this flag is set to be true, Foxit PDF SDK will only render annotations which have annotation flag FSDK.Annot.e_FlagPrint.
If this function is not called for current renderer object yet, default value false will be used.

Parameters

  [in] | is_render_for_print | true means to render in print mode, while false means to render not in print mode.

Returns
  None.

## ◆ IsEmpty()

FSDK.Renderer.IsEmpty | ( |  | ) |

             @brief Constructor, with  postscript device setting data.

             @details All the content rendered by the renderer would appear in PostScrip file.

             @param[in] print_param       Setting data used to postscript device.
             @param[in] dest_psfile_path  The path to generate the printed PostScrip file.
            &zwj;/

Renderer(const PostScriptDeviceSettingData& print_param, const wchar_t* dest_psfile_path); endif

    /**
       @brief Check whether current object is empty or not.

       @details When the current object is empty, that means current object is useless.

       @return <b>true</b> means current object is empty, while <b>false</b> means not.

## ◆ RenderAnnot()

FSDK.Renderer.RenderAnnot | ( | annot | ,
|  | matrix |
| ) |  |

Render a specified annotation.

When this function is called, rendering flag (set by function FSDK.Renderer.SetRenderContentFlags or by default) will be ignored.

Parameters

  [in] | annot | An annotation object to be rendered. If input annot is a pop-up annotation, this function will not render it and will return false.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function FSDK.PDFPage.GetDisplayMatrix.

Returns
  true means success, while false means failure.

## ◆ RenderFormControls()

FSDK.Renderer.RenderFormControls | ( | page | ,
|  | matrix |
| ) |  |

Render form controls.

When this function is called, rendering flag (set by function FSDK.Renderer.SetRenderContentFlags or by default) will be ignored.

Parameters

  [in] | page | A valid PDF page. If input page is invalid, this function do nothing and return false directly.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function FSDK.PDFPage.GetDisplayMatrix.

Returns
  true means success, while false means failure.

## ◆ RenderGraphicsObject()

FSDK.Renderer.RenderGraphicsObject | ( | graphics_object | ,
|  | page | ,
|  | matrix |
| ) |  |

Render a graphics object.

When this function is called, rendering flag (set by function FSDK.Renderer.SetRenderContentFlags or by default) will be ignored.

Parameters

  [in] | graphics_object | A valid PDF graphics object to be rendered.
  [in] | page | A valid PDF page. Parameter graphics_object belongs to this PDF page.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function FSDK.PDFPage.GetDisplayMatrix.

Returns
  true means success, while false means failure.

## ◆ SetClearType()

FSDK.Renderer.SetClearType | ( | is_clear_type |  | ) |

Set the flag to decide whether to use ClearType-like anti-aliasing to render text objects.

If this function is not called, default value true will be used.

Parameters

  [in] | is_clear_type | true means to use ClearType-like anti-aliasing to render text objects. false means not to use ClearType-like anti-aliasing to render text objects.

Returns
  None.

## ◆ SetClipPathFill()

FSDK.Renderer.SetClipPathFill | ( | clip_path | ,
|  | matrix | ,
|  | fill_mode |
| ) |  |

Set clipping path using filled region.

Parameters

  [in] | clip_path | A clipping path.
  [in] | matrix | The transformation matrix used for clipping.
  [in] | fill_mode | Fill mode. It should be value FSDK.e_FillModeAlternate or FSDK.e_FillModeWinding.

Returns
  None.

## ◆ SetClipPathStroke()

FSDK.Renderer.SetClipPathStroke | ( | clip_path | ,
|  | matrix | ,
|  | graph_state |
| ) |  |

Set clipping path using stroked region.

Parameters

  [in] | clip_path | A clipping path.
  [in] | matrix | The transformation matrix used for clipping.
  [in] | graph_state | A valid graph state, for pen attributes. If this is null, Foxit PDF SDK will use a graph state object with default constructor. Default value: null.

Returns
  None.

## ◆ SetClipRect()

FSDK.Renderer.SetClipRect | ( | clip_rect |  | ) |

Set the clipping rectangle which will be used in subsequent rendering progress.

Parameters

  [in] | clip_rect | A clipping rectangle. If it is null, that means not to use clipping rectangle in subsequent rendering progress.

Returns
  None.

## ◆ SetColorMode()

FSDK.Renderer.SetColorMode | ( | color_mode |  | ) |

Set color mode.

If this function is not called, default value FSDK.Renderer.e_ColorModeNormal will be used.

Parameters

  [in] | color_mode | Color mode value. It should be one of following values: FSDK.Renderer.e_ColorModeNormal means normal color mode. FSDK.Renderer.e_ColorModeMappingGray means to map white/black color value to background/foreground; for other colors, no change. If this mode is used, please call function FSDK.Renderer.SetMappingModeColors to set "background color" and "foreground color". FSDK.Renderer.e_ColorModeMapping means to map a color value to the color range defined by a background color and a foreground color. If this mode is used, please call function FSDK.Renderer.SetMappingModeColors to set "background color" and "foreground color".

Returns
  None.

## ◆ SetForceDownSample()

FSDK.Renderer.SetForceDownSample | ( | is_to_force_down_sample |  | ) |

Set the flag to decide whether to use down-sampling for image stretching.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_force_down_sample | true means to use down-sampling for image stretching. false means not to use down-sampling for image stretching.

Returns
  None.

## ◆ SetForceHalftone()

FSDK.Renderer.SetForceHalftone | ( | is_to_force_halftone |  | ) |

Set the flag to decide whether to use halftone for image stretching.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_force_halftone | true means to use halftone for image stretching. false means not to use halftone for image stretching.

Returns
  None.

## ◆ SetForegroundColor()

FSDK.Renderer.SetForegroundColor | ( | foreground_color |  | ) |

Set foreground color for text, path or both when color mode is FSDK.Renderer.e_ColorModeForeground.

The foreground color for text, path, or both is determined by the foreground color mode set by the function FSDK.Renderer.SetForegroundColorMode.

Parameters

  [in] | foreground_color | The foreground color for text, path, or both. Format: 0xAARRGGBB.

Returns
  None.

## ◆ SetForegroundColorMode()

FSDK.Renderer.SetForegroundColorMode | ( | foreground_color_mode |  | ) |

Set rendering foreground color mode when color mode is FSDK.Renderer.e_ColorModeForeground.

If this function is not called, default value (FSDK.Renderer.e_ColorModeForegroundText | FSDK.Renderer.e_ColorModeForegroundPath | FSDK.Renderer.e_ColorModeForegroundBlackText | FSDK.Renderer.e_ColorModeForegroundBlackPath) will be used.

Parameters

  [in] | foreground_color_mode | Rendering foreground color mode. Please refer to values starting from FSDK.Renderer.e_ColorModeForegroundText and this should be one or a combination of these values.

Returns
  None.

## ◆ SetJPEGDownSample()

FSDK.Renderer.SetJPEGDownSample | ( | is_jepg_down_sample |  | ) |

Set the flag to decide whether to use down-sampling for jpeg image.

Whether to use down-sampling for jpeg image or not will affect rendering result for a PDF page. When current function is called successfully, user should called function FSDK.PDFPage.ClearRenderCache for a PDF page (which has been rendered at least once) before rendering the PDF page again.
If this function is not called, default value true will be used.

Parameters

  [in] | is_jepg_down_sample | true means to use down-sampling for jpeg image. false means not to use down-sampling for jpeg image.

Returns
  None.

## ◆ SetJPXDownSample()

FSDK.Renderer.SetJPXDownSample | ( | is_jpx_down_sample |  | ) |

Set the flag to decide whether to use down-sampling for jpx image.

Whether to use down-sampling for jpx image or not will affect rendering result for a PDF page. When current function is called successfully, user should called function FSDK.PDFPage.ClearRenderCache for a PDF page (which has been rendered at least once) before rendering the PDF page again.
If this function is not called, default value true will be used.

Parameters

  [in] | is_jpx_down_sample | true means to use down-sampling for jpx image. false means not to use down-sampling for jpx image.

Returns
  None.

## ◆ SetLayerContext()

FSDK.Renderer.SetLayerContext | ( | layer_context |  | ) |

Set layer context to render context handle.

In order to render one layer when PDF page's contents is rendered on a rendering context, user should call this function to set the layer context to render context.

Parameters

  [in] | layer_context | A layer context object.

Returns
  None.

## ◆ SetMappingModeColors()

FSDK.Renderer.SetMappingModeColors | ( | background_color | ,
|  | foreground_color |
| ) |  |

Set background color and foreground color when color mode is FSDK.Renderer.e_ColorModeMappingGray or FSDK.Renderer.e_ColorModeMapping.

Parameters

  [in] | background_color | The background color. Format: 0xAARRGGBB.
  [in] | foreground_color | The foreground color. Format: 0xAARRGGBB.

Returns
  None.

## ◆ SetOverprint()

FSDK.Renderer.SetOverprint | ( | is_to_enable_overprint |  | ) |

Set the flag to decide whether to enable overprint.

Parameters

  [in] | is_to_enable_overprint | true means to enable overprint. false means not to enable overprint. Default: false.

Returns
  None.

## ◆ SetPrintTextAsGraphic()

FSDK.Renderer.SetPrintTextAsGraphic | ( | is_to_print_text_graphic |  | ) |

Set the flag to decide whether to print text as path or bitmap.

When this flag is true, Foxit PDF SDK will render text in different way: if font size is greater than 50, print text as path; otherwise, print text as bitmap.
If this function is not called, default value false will be used.

Parameters

  [in] | is_to_print_text_graphic | true means to print text as path or bitmap. false means not to print text as path or bitmap.

Returns
  None.

## ◆ SetPrintTextAsImage()

FSDK.Renderer.SetPrintTextAsImage | ( | is_to_print_text_image |  | ) |

Set the flag to decide whether to print text as image.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_print_text_image | true means to print text as image. false means not to print text as image.

Returns
  None.

## ◆ SetRenderAnnotAppearanceType()

FSDK.Renderer.SetRenderAnnotAppearanceType | ( | ap_type |  | ) |

Set the annotation's appearance type for rendering.

Parameters

  [in] | ap_type | Type of annotation's appearance. Please refer to values starting from FSDK.Annot.e_AppearanceTypeNormal and this should be one of these values.

Returns
  None.

## ◆ SetRenderAnnotsForThumbnail()

FSDK.Renderer.SetRenderAnnotsForThumbnail | ( | is_render_annots_for_thumbnail |  | ) |

Set rendering flag to decide whether to render annotations in thumbnail mode or not.

In thumbnail mode, the flags of annotations, "NoZoom" and "NoRotate", will be ignored. This rendering flag is available only when flag FSDK.Renderer.e_RenderAnnot is used for rendering or function FSDK.Renderer.RenderAnnot is called. Please refer to function FSDK.Renderer.SetRenderContentFlags about setting flag FSDK.Renderer.e_RenderAnnot.
If this function is not called, default value false will be used when this rendering flag is available.

Parameters

  [in] | is_render_annots_for_thumbnail | true means to render annotations in thumbnail mode. false means not to render annotations in thumbnail mode.

Returns
  None.

## ◆ SetRenderContentFlags()

FSDK.Renderer.SetRenderContentFlags | ( | render_content_flags |  | ) |

Set rendering flag to decide what content will be rendered.

If this function is not called, default value (FSDK.Renderer.e_RenderPage | FSDK.Renderer.e_RenderAnnot) will be used.

Parameters

  [in] | render_content_flags | Rendering content flags. Please refer to values starting from FSDK.Renderer.e_RenderPage and this should be one or a combination of these values.

Returns
  None.

## ◆ SetRenderEnhanceThinLines()

FSDK.Renderer.SetRenderEnhanceThinLines | ( | is_render_enhance_thin_lines |  | ) |

Set the flag to decide whether to enhance thin lines.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_enhance_thin_lines | true means to draw zero width lines with a thicker path so they are more visible than the default single pixel. false means to draw zero width lines with a single pixel width.

Returns
  None.

## ◆ SetRenderFormField()

FSDK.Renderer.SetRenderFormField | ( | is_render_formfield |  | ) |

Set the flag to decide whether to render form fields (except signature fields).

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_formfield | true means to render form fields (except signature fields). false means not to render form fields (except signature fields).

Returns
  None.

## ◆ SetRenderImageAntiAliasing()

FSDK.Renderer.SetRenderImageAntiAliasing | ( | is_render_image_antialiasing |  | ) |

Set the flag to decide whether to draw image anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_image_antialiasing | true means to draw image anti-aliasing, and the effect would be similar to values defined in enum class InterpolationFlag. false means to draw image aliasing.

Returns
  None.

## ◆ SetRenderLayer()

FSDK.Renderer.SetRenderLayer | ( | is_render_one_layer |  | ) |

Set the flag to decide whether to render one layer or all available layers.

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_one_layer | true means to render one layer. false means to render all available layers.

Returns
  None.

## ◆ SetRenderPathAntiAliasing()

FSDK.Renderer.SetRenderPathAntiAliasing | ( | is_render_path_antialiasing |  | ) |

Set the flag to decide whether to draw path anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_path_antialiasing | true means to draw path anti-aliasing. false means to draw path aliasing.

Returns
  None.

## ◆ SetRenderPathFullCovered()

FSDK.Renderer.SetRenderPathFullCovered | ( | is_render_path_full_covered |  | ) |

A special flag that can be applied to fill mode.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_path_full_covered | true means that all pixels partially covered by the path will be fully painted, while false means not.

Returns
  None.

## ◆ SetRenderPathThinLine()

FSDK.Renderer.SetRenderPathThinLine | ( | is_render_path_thin_line |  | ) |

Set the flag to decide whether to draw path as thin line.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_path_thin_line | true means to draw path as thin line. false means not to draw path as thin line.

Returns
  None.

## ◆ SetRenderSignature()

FSDK.Renderer.SetRenderSignature | ( | is_render_signature |  | ) |

Set the flag to decide whether to render signatures or not.

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_signature | true means to render signatures. false means not to render signatures.

Returns
  None.

## ◆ SetRenderSignatureState()

FSDK.Renderer.SetRenderSignatureState | ( | is_render_signature_state |  | ) |

Set the flag to decide whether to draw the signature state on the signature.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_signature_state | true means to draw the signature state on the signature, while false means not.

## ◆ SetRenderTextAntiAliasing()

FSDK.Renderer.SetRenderTextAntiAliasing | ( | is_render_text_antialiasing |  | ) |

Set the flag to decide whether to draw text anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_text_antialiasing | true means to draw text anti-aliasing. false means to draw text aliasing.

Returns
  None.

## ◆ SetScreenDPIScale()

FSDK.Renderer.SetScreenDPIScale | ( | scale |  | ) |

Set the screen DPI scaling factor for rendering.

Set the screen DPI scaling scale to adapt to different DPI conditions. This value should typically match the system-reported scaling factor (e.g., 1.25 for 125% scaling in display settings) to ensure proper rendering alignment with the physical display characteristics.

Parameters

  [in] | scale | The scale of curren screen DPI(1.0 = 100% native DPI, 2.0 = 200%, etc.). Must be greater than 0 and should generally correspond to the system's recommended scaling factor. default value: 1.0f for non-Android platforms, 2.5f for Android platform.

Note
  Currently, this screen DPI scaling factor only affects the annotations.

Returns
  None.

## ◆ StartQuickRender()

FSDK.Renderer.StartQuickRender | ( | page | ,
|  | matrix | ,
|  | pause |
| ) |  |

Start to quickly render a PDF page, mainly for thumbnail purpose.

This function is mainly used for render a page for thumbnail purpose. The rendered content will not be completed: all the annotations will be ignored, event if flag FSDK.Renderer.e_RenderAnnot is set by function FSDK.Renderer.SetRenderContentFlags; text content will become blurred and will be replace by pixel point.
It may still take a long time to do this quick rendering when page has complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | page | A valid PDF page. It should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function FSDK.PDFPage.GetDisplayMatrix.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function FSDK.Progressive.GetRateOfProgress. If the rate is not 100 yet, call function FSDK.Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRender()

FSDK.Renderer.StartRender | ( | page | ,
|  | matrix | ,
|  | pause |
| ) |  |

Start to render a PDF page.

It may take a long time to render a PDF page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.
Widget annotation is always associated with form field and form control in Foxit PDF SDK. For how to render widget annotations, here is a recommended flow:

- After loading a PDF page, first render the page and all annotations in this page (including widget annotations).
- Then, if user uses FSDK.Filler object to fill the form, user should use function FSDK.Filler.Render to render the focused form control instead of using function FSDK.Renderer.RenderAnnot.

Parameters

  [in] | page | A valid PDF page. If only to render annotations (that means only FSDK.Renderer.e_RenderAnnot is set by function FSDK.Renderer.SetRenderContentFlags), there is no need to parse the input page; otherwise the input page should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function FSDK.PDFPage.GetDisplayMatrix.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function FSDK.Progressive.GetRateOfProgress. If the rate is not 100 yet, call function FSDK.Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderBitmap() [1/2]

FSDK.Renderer.StartRenderBitmap | ( | bitmap | ,
|  | matrix | ,
|  | clip_rect | ,
|  | interpolation | ,
|  | alpha | ,
|  | pause |
| ) |  |

Start to render a bitmap.

It may take a long time to render a bitmap with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | bitmap | A valid bitmap. User should ensure the bitmap to keep valid until current rendering process is finished.
  [in] | matrix | The transformation matrix used for rendering. This matrix is used as image matrix: assume that h is image height, w is image width, and then matrix [w 0 0 h 0 0] will produce an identical image.
  [in] | clip_rect | Clip rectangle for the rendering device. This can be NULL.
  [in] | interpolation | Bitmap interpolation flags. Please refer to values starting from FSDK.Bitmap.e_Downsample and this can be one or a combination of these values. If not specify any flag, please use 0.
  [in] | alpha | Bitmap alpha represents transparency (0 = fully transparent, 255 = fully opaque). Valid range: from 0 to 255.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be NULL which means not to pause during the rendering process. If this is not NULL, it should be a valid pause object implemented by user.

Returns
  A progressive object. Please check the rate of current progress by function FSDK.Progressive.GetRateOfProgress. If the rate is not 100 yet, call function FSDK.Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderBitmap() [2/2]

FSDK.Renderer.StartRenderBitmap | ( | bitmap | ,
|  | matrix | ,
|  | clip_rect | ,
|  | interpolation | ,
|  | pause |
| ) |  |

Start to render a bitmap.

It may take a long time to render a bitmap with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | bitmap | A valid bitmap. User should ensure the bitmap to keep valid until current rendering process is finished.
  [in] | matrix | The transformation matrix used for rendering. This matrix is used as image matrix: assume that h is image height, w is image width, and then matrix [w 0 0 h 0 0] will produce an identical image.
  [in] | clip_rect | Clip rectangle for the rendering device. This can be null. Default value: null.
  [in] | interpolation | Bitmap interpolation flags. Please refer to values starting from FSDK.Bitmap.e_Downsample and this can be one or a combination of these values. If not specify any flag, please use 0. Default value: 0.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function FSDK.Progressive.GetRateOfProgress. If the rate is not 100 yet, call function FSDK.Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderReflowPage()

FSDK.Renderer.StartRenderReflowPage | ( | reflow_page | ,
|  | matrix | ,
|  | pause |
| ) |  |

Start to render a reflow page.

It may take a long time to render a reflow page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | reflow_page | A valid reflow page. It should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function FSDK.ReflowPage.GetDisplayMatrix.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value:null.

Returns
  A progressive object. Please check the rate of current progress by function FSDK.Progressive.GetRateOfProgress. If the rate is not 100 yet, call function FSDK.Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderXFAPage()

FSDK.Renderer.StartRenderXFAPage | ( | xfa_page_view | ,
|  | matrix | ,
|  | is_highlight | ,
|  | pause |
| ) |  |

Start to render an XFA page.

It will take a long time to render an XFA page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | xfa_page_view | A valid XFA page.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function FSDK.XFAPage.GetDisplayMatrix.
  [in] | is_highlight | true means to highlight XFA widgets, and false means not to highlight XFA widgets.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function FSDK.Progressive.GetRateOfProgress. If the rate is not 100 yet, call function FSDK.Progressive.Continue to continue the progress until the progress is finished.

## Member Data Documentation

## ◆ e_ColorModeNormal

FSDK.Renderer.e_ColorModeNormal
| static

Enumeration for rendering color mode.

Values of this enumeration should be used alone.

Normal color mode.

## ◆ e_RenderPage

FSDK.Renderer.e_RenderPage

Enumeration for rendering content flags.

Values of this enumeration can be used alone or in combination.

If set, page content will be rendered.